/// <reference types="node" />
/// <reference types="node" />
import { IncomingMessage } from 'http';
import { Express } from 'express';
import { EventEmitter } from 'events';
import { OAuth2Issuer } from './oauth2-issuer';
import type { OAuth2EndpointsInput, ScopesOrTransform } from './types';
export declare class OAuth2Service extends EventEmitter {
    #private;
    constructor(oauth2Issuer: OAuth2Issuer, endpoints?: OAuth2EndpointsInput);
    get issuer(): OAuth2Issuer;
    buildToken(req: IncomingMessage, expiresIn: number, scopesOrTransform: ScopesOrTransform | undefined): Promise<string>;
    get requestHandler(): Express;
    private buildRequestHandler;
    private openidConfigurationHandler;
    private jwksHandler;
    private tokenHandler;
    private authorizeHandler;
    private userInfoHandler;
    private revokeHandler;
    private endSessionHandler;
    private introspectHandler;
}
